package rogue 
{
	import flash.display.Sprite;
	import com.greensock.TweenLite;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class Enemy extends Warrior
	{
		
		public var gamePtr:MainGame;
		
		private const ST_IDLE:uint = 0;
		private const ST_HUNT:uint = 1;
		private const ST_FIGHT:uint = 2;
		private const ST_ESCAPE:uint = 3;
		
		private var iaState:uint;
		
		public var warriorName:String;
		
		private var enemyArray:Array;
		
		private var randomDestination:Point;
		
		public static const WarriorNames:Array = ["MAXIMUS", "JULIUS", "LUCY", "REBECCA", "KYROS", "SEVERINO", "NERO", "MARY", "AMILTON", "MARCELLUS"];
		
		public function Enemy() 
		{
			super();
			
			this.collider = body;
			
			active = true;
			
			iaState = ST_IDLE;
		}
		
		/*public function generateRandomName():void
		{
			warriorName = WarriorNames[Math.floor(Math.random() * WarriorNames.length)];
		}*/
		
		public function setEnemyArray(arr:Array):void
		{
			enemyArray = arr;
		}
		
		public function setDificulty(dif:int):void
		{
			switch(dif)
			{
				case 0:
					hp = 100;
					maxHp = 100;
					
					break;
					
				case 1:
					hp = 200;
					maxHp = 200;
					
					break;
					
				case 3:
				default:
					hp = 300;
					maxHp = 300;
			}
		}
		
		override public function update():void
		{
			if (!controlLost)
			{
				var playerSpt:Warrior = gamePtr.getPlayer();
				var distance:Number = Math.sqrt((playerSpt.y - y)*(playerSpt.y - y) +  (playerSpt.x - x)*(playerSpt.x - x));
		
				switch (iaState)
				{
					case ST_IDLE:
							if (distance < 500)
							{
								iaState = ST_HUNT;
							}
							
						break;
						
					case ST_HUNT:
						if (distance > 520)
						{
							iaState = ST_IDLE;
						}
						else if (distance > 80)
						{
							this.rotation = (Math.atan2(playerSpt.y - y, playerSpt.x - x) * 180 / Math.PI) - 30;
							
							var oldX:Number = this.x;
							var oldY:Number = this.y;
							
							this.x += Math.cos(this.rotation * Math.PI / 180) * 5;
							this.y += Math.sin(this.rotation * Math.PI / 180) * 5;
							
							if (enemyArray.length > 1 && distance < 150)
							{
								for (var i:int = 0; i < enemyArray.length; i++)
								{
									if (enemyArray[i].active && enemyArray[i] != this)
									{
										if (this.collider.hitTestObject(enemyArray[i].collider))
										{
											iaState = ST_ESCAPE;
											randomDestination = new Point(Math.floor(Math.random() * 400) + 10, Math.floor(Math.random() * 400) + 325);
											trace("destination " + randomDestination.x + " " + randomDestination.y);
											this.rotation = (Math.atan2(randomDestination.y - y, randomDestination.x - x) * 180 / Math.PI) - 30;
											break;
										}
									}
								}
							}

						}
						else
						{
							iaState = ST_FIGHT;	
						}
						
						break;
					
					case ST_FIGHT:
						TweenLite.to(this, 0.3, { rotation:(Math.atan2(playerSpt.y - y, playerSpt.x - x) * 180 / Math.PI) - 30 });
						
						if (distance > 120)
						{
							iaState = ST_HUNT;
							break;
						}
						else
						{
							if (playerSpt.isAttacking())
								this.shieldUp();
							
							if (!holdingAttack && !attacking)
							{
								this.shieldDown();
								prepareAttack();
							}
							else if (holdingAttack && strength < 50)
							{
								prepareAttack();
							}
							else if (strength >= 50 && !attacking)
							{
								attack();
							}
						}
						break;
						
					case ST_ESCAPE:
						var pointDist:Number = Math.sqrt((randomDestination.y - y)*(randomDestination.y - y) +  (randomDestination.x - x)*(randomDestination.x - x));
						
						this.rotation = (Math.atan2(randomDestination.y - y, randomDestination.x - x) * 180 / Math.PI);
						
						if (pointDist < 20)
						{
							iaState = ST_HUNT;
						}	
						else
						{
							this.x += Math.cos(this.rotation * Math.PI / 180) * 5;
							this.y += Math.sin(this.rotation * Math.PI / 180) * 5;
						}
						break;
					
				}
			
			}
		}
	}

}