package rogue 
{
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class Input 
	{
		
		private static var keyPressed:Vector.<Boolean> = new Vector.<Boolean>(256);
		private static var keyReleased:Vector.<Boolean> = new Vector.<Boolean>(256);
		
		private static var mousePressed:Boolean = false;
		
		public function Input() 
		{
			
		}
		
		public static function initialize():void
		{
			Globals.stage.addEventListener(KeyboardEvent.KEY_DOWN, onKeyDown);
			Globals.stage.addEventListener(KeyboardEvent.KEY_UP, onKeyUp);
			Globals.stage.addEventListener(MouseEvent.MOUSE_DOWN, onMousePress);
			Globals.stage.addEventListener(MouseEvent.MOUSE_UP, onMouseRelease);
		}
		
		private static function onKeyDown(event:KeyboardEvent):void
		{
			keyPressed[event.keyCode] = true;
			keyReleased[event.keyCode] = false;
		}
		
		private static function onKeyUp(event:KeyboardEvent):void
		{
			keyReleased[event.keyCode] = true;
			keyPressed[event.keyCode] = false;
		}
		
		private static function onMousePress(event:MouseEvent):void
		{
			mousePressed = true;
		}
		
		private static function onMouseRelease(event:MouseEvent):void
		{
			mousePressed = false;
		}		
		
		public static function isPressed(code:uint):Boolean
		{
			return keyPressed[code];
		}
		
		public static function isReleased(code:uint):Boolean
		{
			return keyReleased[code];
		}
		
		public static function isMousePressed():Boolean
		{
			return mousePressed;
		}		
		
		public static function update():void
		{
			//mousePressed = false;
		}
	}

}