package rogue 
{
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class LevelMap extends Sprite
	{
		private var ROWS:uint = 5;
		private var COLS:uint = 5;
		private var ROOMSIZE:uint = 800;
		
		private var rooms:Array;
		
		public function LevelMap() 
		{
			rooms = new Array();
			
			for (var i:int = 0; i < 20; i++)
			{
				rooms[i] = buildRoom();
				
				rooms[i].x = 10 + ((i/ROWS) * (ROOMSIZE+10));
				rooms[i].y = 10 + ((i % COLS) * (ROOMSIZE+10));
				
				this.addChild(rooms[i]);
			}
		}
		
		private function buildRoom():Sprite
		{
			var newRoom:Sprite = new Sprite();
			
			newRoom.graphics.lineStyle(3, 0xff0000);
			newRoom.graphics.drawRect(0, 0, ROOMSIZE, ROOMSIZE);
			
			return newRoom;
		}
		
		public function checkCollision(sprite:GameSprite):Boolean
		{
			for (var i:int = 0; i < rooms.length; i++)
			{
				if (sprite.hitTestObject(rooms[i]))
				{
					//trace("hit test " + i);
					var sptBmp:BitmapData = new BitmapData(sprite.collider.width, sprite.collider.height, true, 0);
					sptBmp.draw(sprite.collider, null, null, null, new Rectangle(-20, -20, sprite.collider.width, sprite.collider.height));
					var roomBmp:BitmapData = new BitmapData(rooms[i].width, rooms[i].height, true, 0);
					roomBmp.draw(rooms[i]);
					
					if (sptBmp.hitTest(new Point(sprite.x - rooms[i].x, sprite.y - rooms[i].y ), 1, roomBmp, new Point(0, 0), 1))
						return true;
				}
			}
			
			return false;
		}
		
	}

}