package rogue 
{
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.events.MouseEvent;
	
	import com.greensock.TweenLite;
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class MenuScreen extends GameScene
	{
		[Embed(source="../../resources/hat1.png")]
		public var IMG_HAT1:Class;		
		[Embed(source="../../resources/hat2.png")]
		public var IMG_HAT2:Class;		
		[Embed(source="../../resources/hat3.png")]
		public var IMG_HAT3:Class;		
		[Embed(source="../../resources/hat4.png")]
		public var IMG_HAT4:Class;		
		
		[Embed(source="../../resources/sword.png")]
		public var IMG_SWORD:Class;		
		[Embed(source="../../resources/spear.png")]
		public var IMG_SPEAR:Class;		
		[Embed(source="../../resources/axe.png")]
		public var IMG_AXE:Class;
		
		private var txtTitle:TextField;
		private var txtHatChoose:TextField;
		private var txtWeaponChoose:TextField;
		private var hats:Array;
		private var weapons:Array;
		
		private var hatBox:Sprite;
		private var wpnBox:Sprite;
		
		private var readyButton:Sprite;
		private var readyBox:Sprite;
		
		private var selectedHat:int = 0;
		private var selectedWpn:int = 0;
		
		private var blankOverlay:Sprite;
		
		public function MenuScreen() 
		{
			super();
			
			txtTitle = new TextField();
			txtTitle.selectable = false;
			txtTitle.width = 400;
			txtTitle.embedFonts = true;
			txtTitle.defaultTextFormat = new TextFormat("Vectrexfake", 50, 0xff0000);
			txtTitle.text = "EQUIP YOUR GLADIATOR";
			
			txtTitle.x = 150;
			txtTitle.y = 5;
			
			this.addChild(txtTitle);
			
			txtHatChoose = new TextField();
			txtHatChoose.selectable = false;
			txtHatChoose.width = 300;
			txtHatChoose.embedFonts = true;
			txtHatChoose.defaultTextFormat = new TextFormat("Vectrexfake", 40, 0xff0000);
			txtHatChoose.text = "CHOOSE YOUR FUNNY HAT";
			
			txtHatChoose.x = 10;
			txtHatChoose.y = 100;
			
			this.addChild(txtHatChoose);		
			
			txtWeaponChoose = new TextField();
			txtWeaponChoose.selectable = false;
			txtWeaponChoose.width = 300;
			txtWeaponChoose.embedFonts = true;
			txtWeaponChoose.defaultTextFormat = new TextFormat("Vectrexfake", 40, 0xff0000);
			txtWeaponChoose.text = "CHOOSE YOUR WEAPON";
			
			txtWeaponChoose.x = 400;
			txtWeaponChoose.y = 100;
			
			this.addChild(txtWeaponChoose);
			
			hats = new Array();
			hats[0] = new Sprite();
			hats[0].addChild(new IMG_HAT1());
			
			hats[1] = new Sprite();
			hats[1].addChild(new IMG_HAT2());
			
			hats[2] = new Sprite();
			hats[2].addChild(new IMG_HAT3());
			
			hats[3] = new Sprite();
			hats[3].addChild(new IMG_HAT4());
			
			var i:int;
			for (i = 0; i < hats.length; i++)
			{
				hats[i].x = 30;
				hats[i].y = 150 + (hats[i].height+10) * i;
				this.addChild(hats[i]);
				hats[i].addEventListener(MouseEvent.MOUSE_OVER, onMouseOverHat);
				hats[i].addEventListener(MouseEvent.MOUSE_OUT, onMouseOutHat);
				hats[i].addEventListener(MouseEvent.MOUSE_UP, onMouseUpHat);
			}
			
			hatBox = new Sprite();
			this.addChild(hatBox);
			
			hatBox.x = hats[0].x;
			hatBox.y = hats[0].y;
			
			hatBox.graphics.lineStyle(2, 0xffffff);
			hatBox.graphics.drawRect(0, 0, hats[0].width, hats[0].height);
			
			
			weapons = new Array();
			weapons[0] = new Sprite();
			weapons[0].addChild(new IMG_SWORD());
			
			weapons[1] = new Sprite();
			weapons[1].addChild(new IMG_AXE());
			
			weapons[2] = new Sprite();
			weapons[2].addChild(new IMG_SPEAR());
			
			for (i = 0; i < weapons.length; i++)
			{
				weapons[i].x = 430;
				
				if (i == 0)
					weapons[i].y = 150;
				else
					weapons[i].y = 150 + (weapons[i - 1].height + 10) * i;
					
				this.addChild(weapons[i]);
				weapons[i].addEventListener(MouseEvent.MOUSE_OVER, onMouseOverWeapons);
				weapons[i].addEventListener(MouseEvent.MOUSE_OUT, onMouseOutWeapons);
				weapons[i].addEventListener(MouseEvent.MOUSE_UP, onMouseUpWeapons);
			}
			
			wpnBox = new Sprite();
			this.addChild(wpnBox);
			
			wpnBox.x = weapons[0].x;
			wpnBox.y = weapons[0].y;			
			
			wpnBox.graphics.lineStyle(2, 0xffffff);
			wpnBox.graphics.drawRect(0, 0, weapons[0].width, weapons[0].height);
			
			
			readyButton = new Sprite();
			
			var readyFill:Sprite = new Sprite();
			
			readyFill.graphics.beginFill(0x000000);
			readyFill.graphics.drawRect(0, 0, 150, 50);
			readyFill.graphics.endFill();
			
			readyButton.addChild(readyFill);
			readyButton.buttonMode = true;
			
			readyBox = new Sprite();
			
			readyBox.graphics.lineStyle(2, 0xff0000);
			readyBox.graphics.drawRect(0, 0, 150, 50);
			readyBox.visible = false;
			readyButton.addChild(readyBox);			
			
			var readyText:TextField = new TextField();
			readyText.width = 100;
			readyText.selectable = false;
			readyText.embedFonts = true;
			readyText.defaultTextFormat = new TextFormat("Vectrexfake", 50, 0xff0000);
			readyText.text = "READY?";
			readyText.x = 30;
			readyText.y = 8;
			readyButton.addChild(readyText);
			
			
			readyButton.x = 220;
			readyButton.y = 600;
			
			this.addChild(readyButton);
			
			readyButton.addEventListener(MouseEvent.MOUSE_OVER, onReadyOver);
			readyButton.addEventListener(MouseEvent.MOUSE_OUT, onReadyOut);
			readyButton.addEventListener(MouseEvent.MOUSE_UP, onReadyUp);
			
			blankOverlay = new Sprite();
			blankOverlay.graphics.beginFill(0xffffff);
			blankOverlay.graphics.drawRect(0, 0, 650, 794);
			blankOverlay.graphics.endFill();		
			
			blankOverlay.visible = false;
			
			SoundManager.getInstance().playBGM();
			
		}
		
		private function onMouseOverHat(event:MouseEvent):void
		{
			hatBox.x = event.target.x;
			hatBox.y = event.target.y;
			
			hatBox.graphics.lineStyle(2, 0xff0000);
			hatBox.graphics.drawRect(0, 0, event.target.width, event.target.height);
		}
		
		private function onMouseOutHat(event:MouseEvent):void
		{
			hatBox.x = hats[selectedHat].x;
			hatBox.y = hats[selectedHat].y;
			
			hatBox.graphics.lineStyle(2, 0xffffff);
			hatBox.graphics.drawRect(0, 0, hats[selectedHat].width, hats[selectedHat].height);
		}
		
		private function onMouseUpHat(event:MouseEvent):void
		{
			for (var i:int = 0; i < hats.length; i++)
			{
				if (event.target == hats[i])
				{
					selectedHat = i;
					break;
				}
			}
			
			onMouseOutHat(null);
			
			SoundManager.getInstance().playSound(GlobalSounds.SFX_CHECK);
		}		
		
		private function onMouseOverWeapons(event:MouseEvent):void
		{
			wpnBox.x = event.target.x;
			wpnBox.y = event.target.y;
			
			wpnBox.graphics.clear();
			wpnBox.graphics.lineStyle(2, 0xff0000);
			wpnBox.graphics.drawRect(0, 0, event.target.width, event.target.height);
		}
		
		private function onMouseOutWeapons(event:MouseEvent):void
		{
			wpnBox.x = weapons[selectedWpn].x;
			wpnBox.y = weapons[selectedWpn].y;
			
			wpnBox.graphics.clear();
			wpnBox.graphics.lineStyle(2, 0xffffff);
			wpnBox.graphics.drawRect(0, 0, weapons[selectedWpn].width, weapons[selectedWpn].height);
		}
		
		private function onMouseUpWeapons(event:MouseEvent):void
		{
			for (var i:int = 0; i < weapons.length; i++)
			{
				if (event.target == weapons[i])
				{
					selectedWpn = i;
					break;
				}
			}
			
			SoundManager.getInstance().playSound(GlobalSounds.SFX_CHECK);
			
			onMouseOutWeapons(null);
		}	
		
		private function onReadyOver(event:MouseEvent):void
		{
			readyBox.visible = true;
		}
		
		private function onReadyOut(event:MouseEvent):void
		{
			readyBox.visible = false;
		}
		
		private function onReadyUp(event:MouseEvent):void
		{
			readyBox.graphics.lineStyle(2, 0xffffff);
			readyBox.graphics.drawRect(0, 0, 150, 50);
			
			SoundManager.getInstance().playSound(GlobalSounds.SFX_CHECK);
			
			var i:int;
			for (i = 0; i < hats.length; i++)
			{
				hats[i].removeEventListener(MouseEvent.MOUSE_OVER, onMouseOverHat);
				hats[i].removeEventListener(MouseEvent.MOUSE_OUT, onMouseOutHat);
				hats[i].removeEventListener(MouseEvent.MOUSE_UP, onMouseUpHat);
			}
			
			hatBox = new Sprite();

			for (i = 0; i < weapons.length; i++)
			{
				weapons[i].removeEventListener(MouseEvent.MOUSE_OVER, onMouseOverWeapons);
				weapons[i].removeEventListener(MouseEvent.MOUSE_OUT, onMouseOutWeapons);
				weapons[i].removeEventListener(MouseEvent.MOUSE_UP, onMouseUpWeapons);
			}
			
			readyButton.removeEventListener(MouseEvent.MOUSE_OVER, onReadyOver);
			readyButton.removeEventListener(MouseEvent.MOUSE_OUT, onReadyOut);
			readyButton.removeEventListener(MouseEvent.MOUSE_UP, onReadyUp);
			
			GlobalPlayerData.playerHat = selectedHat;
			GlobalPlayerData.playerWeapon = selectedWpn;
			
			blankOverlay.alpha = 0;
			this.addChild(blankOverlay);
			blankOverlay.visible = true;
			TweenLite.to(blankOverlay, 0.3, { alpha:1.0, delay:0.5, onComplete:changeScene } );
		}	
		
		private function changeScene():void
		{
			SceneManager.getInstance().setScene(new MainGame());
		}
	}

}