package rogue 
{
	import com.greensock.TweenLite;
	import com.greensock.easing.Quad;
	import flash.events.Event;
	
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class WeaponSpear extends Weapon 
	{
		
		public function WeaponSpear() 
		{
			this.x = -10;
			this.y = 23;
			
			this.graphics.lineStyle(3, 0xffffff);
			this.graphics.lineTo(54, 0);
			this.graphics.moveTo(50, -5);
			this.graphics.lineTo(45, -5);
			this.graphics.lineTo(45, 5);
			this.graphics.lineTo(50, 5);
			//this.rotation = 70;
		}
		
		override public function prepare():void
		{
			this.x = 2;
			this.rotation = 0;
		}		
		
		override public function charge(strength:Number):void
		{
			this.x = -(strength/5) - 10;
		}		
		
		override public function attack(strength:Number):void
		{
			SoundManager.getInstance().playSound(GlobalSounds.SFX_WEAPON);	
			TweenLite.to(this, strength/200, { x:strength/5, onUpdate:updateweaponPos, onComplete:haltweapon, ease:Quad.easeIn});
		}
		
		override protected function updateweaponPos():void
		{
			//var rad:Number = (this.rotation) * Math.PI / 180;
			//this.x = (30 * Math.cos(rad));
			//this.y = (30 * Math.sin(rad));
		}
		
		override protected function haltweapon():void
		{
			this.x = -10;
			this.y = 23;
			this.rotation = 0;
			
			this.dispatchEvent(new Event(EVENT_ATTACK_FINISH));
		}				
	}

}