package rogue 
{
	import com.greensock.TweenLite;
	import com.greensock.easing.Quad;
	import flash.events.Event;
	
	/**
	 * ...
	 * @author Arthur Zeferino
	 */
	public class WeaponSword extends Weapon 
	{
		
		public function WeaponSword() 
		{
			this.x = 5;
			this.y = 20;
			
			this.graphics.lineStyle(3, 0xffffff);
			this.graphics.lineTo(33, 0);
			this.graphics.moveTo(5, -3);
			this.graphics.lineTo(5, 3);
			this.rotation = 70;
		}
		
		override public function prepare():void
		{
			this.x = 20;
			this.rotation = 0;
		}		
		
		override public function charge(strength:Number):void
		{
			this.rotation = strength+30;
			var rad:Number = (strength+30) * Math.PI / 180;
			this.x = (30 * Math.cos(rad));
			this.y = (30 * Math.sin(rad));
		}
		
		override public function attack(strength:Number):void
		{
			SoundManager.getInstance().playSound(GlobalSounds.SFX_WEAPON);
			TweenLite.to(this, strength/200, { rotation:-strength, onUpdate:updateweaponPos, onComplete:haltweapon, ease:Quad.easeIn});
		}
		
		override protected function updateweaponPos():void
		{
			var rad:Number = (this.rotation) * Math.PI / 180;
			this.x = (30 * Math.cos(rad));
			this.y = (30 * Math.sin(rad));
		}
		
		override protected function haltweapon():void
		{
			this.x = 5;
			this.y = 20;
			this.rotation = 70;
			
			this.dispatchEvent(new Event(EVENT_ATTACK_FINISH));
		}				
		
		override public function loseControl():void
		{
			this.x = 5;
			this.y = 20;
			this.rotation = -10;
		}
		
	}

}